Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.fdk
Class WorkspaceManager

All Superinterfaces:
  java.rmi.Remote

All Known Implementing Classes:
  CoreWorkspaceManager, WorkspaceManagerImpl

    public interface class WorkspaceManager

extends java.rmi.Remote

FDK interface for managing Workspaces.

Method Summary
`Item` | `createPersonalWorkspace(NamedValue[] def, AttributeRequest[] attributes)` Creates a new personal workspace for the current user.
`Item` | `createPersonalWorkspaceForUser(long userId, NamedValue[] def, AttributeRequest[] attributes)` Creates a new personal workspace for the given user.
`Item` | `createWorkspace(long target, NamedValue[] wfParams, NamedValue[] def, AttributeRequest[] attributes)` Creates a new workspace or a request.
`void` | `deleteWorkspace(long id, NamedValue[] def)` Deletes a workspace.
`Item` | `joinWorkspace(long id, long[] reqRoles, NamedValue[] wfParams, AttributeRequest[] attributes)` Requests to join a JoinableWorkspace.
`Item[]` | `listJoinableWorkspaces(NamedValue[] options, AttributeRequest[] attrs)` Lists workspaces that can be joined via request.
`Item` | `updateWorkspace(long id, NamedValue[] def, AttributeRequest[] attributes)` Updates an existing Workspace.

Method Detail

### createWorkspace

    Item createWorkspace(long target,
                         NamedValue[] wfParams,
                         NamedValue[] def,
                         AttributeRequest[] attributes)
                         throws FdkException

  Description copied from interface: `WorkspaceManager`
  Creates a new workspace or a request.

  If workflow is enabled AND 'CreateWorkspace' is workflow enabled, then an item of type 'REQUEST' is returned.

  Otherwise, returns the created Workspace. can return null if the user ends up not having the ability to access the new Workspace.

  Clients should check the type of the Item returned and act accordingly (If it's a request, inform user the request needs to be approved before the workspace can be created.).

  The workspace definition also takes parameters for setting various configuration categories, including SECURITY_CONFIGURATION, VERSIONING_CONFIGURATION, RECORD_CONFIGURATION, and CATEGORY_CONFIGURATION. See the below pattern for SECURITY_CONFIGURATION and the Javadoc for the respective xxxManager.setxxxConfiguration methods.

  To set a WORKFLOW_CONFIGURATION, use the patterns with Options.WORKFLOW_CONFIGURATION_DEFINITION as the top-level NamedValue, and add a NamedValue with Attributes.WORKFLOW_CONFIGURATION_OPERATION to specify the operation. Multiple WORKFLOW_CONFIGURATION_DEFINITIONs may be specified, each with a unique WORKFLOW_CONFIGURATION_OPERATION.

  Parameters:
    `target` - the parent of the new workspace.
    `wfParams` - the parameters (name/value) needed to start workflow.
    `def` - attributes for the Workspace.
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.JOINABLE, Boolean}
    - {Attributes.SECURITY_CONFIGURATION, NamedValue[]}
      where the attributes are:
      - {Attributes.GRANTS, NamedValueSet[]}
        where each row corresponds to a grant whose attributes are:
        - {Attributes.GRANTEE, Long}
        - {Attributes.ROLES, long[]}
        - {Attributes.PROPAGATING, Boolean}
    `attributes` - requested attributes for each item, or null.
  Returns:
    an Item of type REQUEST or WORKSPACE, or null.
  Throws:
    `FdkException` - if the operation fails.

### createPersonalWorkspace

    Item createPersonalWorkspace(NamedValue[] def,
                                 AttributeRequest[] attributes)
                                 throws FdkException

  Description copied from interface: `WorkspaceManager`
  Creates a new personal workspace for the current user.

  Parameters:
    `def` - attributes for the workspace:
    - notation: {Attribute name, Attribute type}
    - (none)
    `attributes` - requested attributes for each item, or null.
  Returns:
    the new personal Workspace.
  Throws:
    `FdkException` - if the operation fails.

### createPersonalWorkspaceForUser

    Item createPersonalWorkspaceForUser(long userId,
                                        NamedValue[] def,
                                        AttributeRequest[] attributes)
                                        throws FdkException

  Description copied from interface: `WorkspaceManager`
  Creates a new personal workspace for the given user.

  Can return null if the creator ends up not having the ability to access the new Workspace.

  Parameters:
    `userId` - the ID of the user.
    `def` - attributes for the workspace:
    - notation: {Attribute name, Attribute type}
    - (none)
    `attributes` - requested attributes for each item, or null.
  Returns:
    the new personal Workspace, or null.
  Throws:
    `FdkException` - if the operation fails.

### updateWorkspace

    Item updateWorkspace(long id,
                         NamedValue[] def,
                         AttributeRequest[] attributes)
                         throws FdkException

  Description copied from interface: `WorkspaceManager`
  Updates an existing Workspace.

  Parameters:
    `id` - the ID of the existing Workspace.
    `def` - attributes to update:
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.JOINABLE, Boolean}
    `attributes` - requested attributes for each item, or null.
  Returns:
    the updated Workspace.
  Throws:
    `FdkException` - if the operation fails.

### deleteWorkspace

    void deleteWorkspace(long id,
                         NamedValue[] def)
                         throws FdkException

  Description copied from interface: `WorkspaceManager`
  Deletes a workspace.

  Parameters:
    `id` - the ID of the existing workspace.
    `def` - attributes for the workspace.
  Throws:
    `FdkException` - if the operation fails.

### listJoinableWorkspaces

    Item[] listJoinableWorkspaces(NamedValue[] options,
                                  AttributeRequest[] attrs)
                                  throws FdkException

  Description copied from interface: `WorkspaceManager`
  Lists workspaces that can be joined via request. Note that the NAME attribute is a name filter; database and Windows wildcards (_?%*) accepted.

  Parameters:
    `options` - Options on the retrieved list. Valid options are:
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Options.PRIMARY_SORT_ATTRIBUTE, String}
    - {Options.PRIMARY_SORT_DIRECTION, Boolean}
    - {Options.SECONDARY_SORT_ATTRIBUTE, String}
    - {Options.SECONDARY_SORT_DIRECTION, Boolean}
    If an attribute name is specified with no direction, ascending is the default. Attribute names must be valid attributes and must return values that implement Comparable.
    `attrs` - attributes to return. Note that the DESCRIPTION attribute will always return null on these objects. To get the description of the Workspace, use the JOINABLE_WORKSPACE_DESCRIPTION attribute.
  Returns:
    An array of items representing joinable workspaces.
  Throws:
    `FdkException` - if the operation fails.

### joinWorkspace

    Item joinWorkspace(long id,
                       long[] reqRoles,
                       NamedValue[] wfParams,
                       AttributeRequest[] attributes)
                       throws FdkException

  Description copied from interface: `WorkspaceManager`
  Requests to join a JoinableWorkspace.

  Parameters:
    `id` - the ID of the JoinableWorkspace to join.
    `reqRoles` - array of requested role IDs.
    `wfParams` - the parameters (name/value) used to start workflow the workflow parameter IFS_ECM_WORKFLOW_JUSTIFICATION must be supplied for this call to succeed.
    `attributes` - requested attributes from the resulting request.
  Returns:
    the request; upon approval the user will be added.
  Throws:
    `FdkException` - if the operation fails.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD